<?php
/**
 * Plugin Name: Feed Close
 * Plugin URI: https://devvver.ru
 * Description: This plugin redirects category, comment, and author feeds to their respective pages.
 * Version: 1.0
 * Author: Evhen Moldovanu
 * Author URI: https://devvver.ru
 */

function redirect_category_comment_author_feeds() {
    // Проверяем, что это не основной фид сайта
    if (is_feed()) {

        // Проверка для фидов комментариев
        if (is_comment_feed()) {
            // Если это запись, редирект на URL самой записи
            if (is_singular()) {
                wp_redirect(get_permalink(), 301);
                exit;
            }
            // Если это категория, метка или таксономия, редирект на соответствующую страницу
            elseif (is_category() || is_tag() || is_tax()) {
                $term = get_queried_object();
                if ($term && isset($term->term_id)) {
                    wp_redirect(get_term_link($term->term_id), 301);
                    exit;
                }
            }
        }

        // Проверка для фидов категорий
        elseif (is_category() || is_tag() || is_tax()) {
            $term = get_queried_object();
            if ($term && isset($term->term_id)) {
                wp_redirect(get_term_link($term->term_id), 301);
                exit;
            }
        }

        // Проверка для фидов авторов
        elseif (is_author()) {
            $author_id = get_queried_object_id();
            wp_redirect(get_author_posts_url($author_id), 301);
            exit;
        }
    }
}

add_action('template_redirect', 'redirect_category_comment_author_feeds');
